;* ************************************************************************ *
;*   Motorola                                      *
;* ************************************************************************ *
.include "tn43udef.inc"

;  : RSTDISBL=WDTON=BODLEVEL1=SUT0=CKSEL3=CKSEL2=CKSEL0=0
.set    VERSION = 0x10                  ; 1.0,  

; *  *
.equ    MAX_MOD = 2                     ;    

; *   EEPROM *
.equ    MA_PMOD = 0x10                  ;    

; *    *
;  A
.equ    CTAout  = PORTA                 ;  
.equ    CTAcfg  = DDRA                  ;  
.equ    CTAin   = PINA                  ;  

.equ    DBGpin  = 7                     ; debug
.equ    LED1pin = 6                     ; LED1
.equ    LED2pin = 5                     ; LED2
.equ    LED3pin = 4                     ; LED3
.equ    BUSPpin = 2                     ; BUS+
.equ    SCIRpin = 1                     ; SCI RX+
.equ    BUSYpin = 0                     ; BUSY
.equ    CTA_CFG = (1<<LED1pin)|(1<<LED2pin)|(1<<LED3pin)|(0<<BUSPpin)|(0<<SCIRpin)|(0<<BUSYpin)
.equ    CTA_OUT = (1<<LED1pin)|(1<<LED2pin)|(1<<LED3pin)|(0<<BUSPpin)|(0<<SCIRpin)|(0<<BUSYpin)

;  B
.equ    CTBout  = PORTB                 ;  
.equ    CTBcfg  = DDRB                  ;  
.equ    CTBin   = PINB                  ;  

.equ    CTSpin  = 7                     ; CTS out, PP
.equ    DTRpin  = 6                     ; DTR in, IN
.equ    RXDpin  = 5                     ; RxD out, PP
.equ    TXDpin  = 4                     ; TxD in, IN
.equ    KEYpin  = 2                     ; local key
.equ    HVKpin  = 1                     ; high voltage PWM, PP
.equ    HPOpin  = 0                     ; high voltage power source, PP
.equ    CTB_CFG = (1<<CTSpin)|(0<<DTRpin)|(1<<RXDpin)|(0<<TXDpin)|(0<<KEYpin)|(1<<HVKpin)|(0<<HPOpin)
.equ    CTB_OUT = (0<<CTSpin)|(0<<DTRpin)|(1<<RXDpin)|(0<<TXDpin)|(1<<KEYpin)|(0<<HVKpin)|(0<<HPOpin)

; *   *
; registers
.def    invCTS  = R15                   ;    CTS

.def    porB    = R16                   ;   
.def    poutB   = R17                   ; out   B
.def    pmod    = R18                   ;   
.def    tmp1    = R19                   ;   
.def    tmp2    = R20                   ;   
.def    tmp3    = R21                   ;   
.def    tmp4    = R22                   ;   

;  
        .cseg                           ; CODE segment
;______________________________________________________________
;  
        .org    0
        rjmp    main_rstcold            ;  

;**************************************************************
; EEPROM
;______________________________________________________________
;     NVM: IN-tmp1(), tmp2()
eewr:
        wdr                             ;  WDT
        sbic    EECR,EEPE               ;    
        rjmp    eewr                    ;   
        push    tmp1                    ;  
        ldi     tmp1,(0<<EEPM1)|(0<<EEPM0)
        out     EECR,tmp1               ;    EEPROM
        pop     tmp1                    ;  
        out     EEAR,tmp2               ;   EEPROM
        out     EEDR,tmp1               ;    
        sbi     EECR,EEMPE              ;   
        ret                             ; 

;______________________________________________________________
;     NVM: IN-tmp2(), OUT-tmp1()
eerd:
        wdr                             ;  WDT
        sbic    EECR,EEPE               ;    
        rjmp    eerd                    ;   
        out     EEAR,tmp2               ;   EEPROM
        sbi     EECR,EERE               ;  
        in      tmp1,EEDR               ;    
        ret                             ; 

;**************************************************************
; UTL
;______________________________________________________________
;  PWM   +12
pwr_init:
        ldi     tmp1,(1<<COM0A1)|(1<<COM0A0)|(1<<WGM01)|(1<<WGM00)
        out     TCCR0A,tmp1             ;  Fast PWM_A
        ldi     tmp1,(1<<CS00)          ;   Fast PWM
        out     TCCR0B,tmp1             ;  Fast PWM_B
        ldi     tmp1,0xE8               ;   PWM
        out     OCR0A,tmp1              ;  
        sbr     poutB,(1<<HPOpin)       ;    +12
        ret                             ; 

;______________________________________________________________
;   
delay_long:
        push    tmp1                    ;  tmp1
        ldi     tmp1,0x10               ;    H
dell_lpH:
        push    tmp1                    ;  tmp1
        clr     tmp1                    ;    M
dell_lpM:
        push    tmp1                    ;  tmp1
        clr     tmp1                    ;    L
dell_lpL:
        wdr                             ;  WD
        dec     tmp1                    ;    L
        brne    dell_lpL                ;   L
        pop     tmp1                    ;   tmp1
        dec     tmp1                    ;    M
        brne    dell_lpM                ;   M
        pop     tmp1                    ;   tmp1
        dec     tmp1                    ;    H
        brne    dell_lpH                ;   H
        pop     tmp1                    ;  tmp1
        ret                             ; 

;______________________________________________________________
;   
setled:
        cbi     CTAout,LED1pin          ; LED1 = OFF
        cbi     CTAout,LED2pin          ; LED2 = OFF
        cbi     CTAout,LED3pin          ; LED3 = OFF
        tst     pmod                    ;   0
        brne    setl_chkmo1             ; ,    0
        sbi     CTAout,LED1pin          ; LED1 = ON
        ret                             ; 
setl_chkmo1:
        cpi     pmod,1                  ;   1
        brne    setl_setmo2             ; ,    1
        sbi     CTAout,LED2pin          ; LED2 = ON
        ret                             ; 
setl_setmo2:
        sbi     CTAout,LED3pin          ; LED3 = ON
        ret                             ; 

;______________________________________________________________
;      
rst_iface:
        cbi     CTAcfg,BUSPpin          ; BUS+, IN (cfg = 0)
        cbi     CTAout,BUSPpin          ; BUS+, IN (out = 0)
        cbi     CTAcfg,SCIRpin          ; SCI RX+, IN (cfg = 0)
        cbi     CTAout,SCIRpin          ; SCI RX+, IN (out = 0)
        cbi     CTAcfg,BUSYpin          ; BUSY, IN (cfg = 0)
        cbi     CTAout,BUSYpin          ; BUSY, IN (out = 0)
        ldi     tmp1,(1<<CTSpin)        ;     CTS
        mov     invCTS,tmp1             ;
        rjmp    setled                  ;    

;______________________________________________________________
;  0: K-  , BUSY     +5
mode0:
        rcall   rst_iface               ;    ,  
        clr     porB                    ;    
;     
mod0_loop:
        wdr                             ;
        in      tmp1,CTBin              ;   B
        in      tmp2,CTAin              ;   A
; TxD/RxD -> Bus+
        bst     tmp2,BUSPpin            ;   Bus+  T
        bld     poutB,RXDpin            ;   Bus+  RxD
        or      poutB,porB              ;  ,  TxD   1
        sbrs    tmp1,TXDpin             ;   TxD
        rjmp    mod0_busL               ; ,    RxD  (TxD = 0)
        cbi     CTAcfg,BUSPpin          ; Bus+ = 1
        cbr     porB,(1<<RXDpin)        ;  or-   RxD
        rjmp    mod0_dtrproc            ; 
mod0_busL:
        sbi     CTAcfg,BUSPpin          ; Bus+ = 0
        sbr     poutB,(1<<RXDpin)       ;  RxD  1,  TxD 0
        sbr     porB,(1<<RXDpin)        ;  or-   RxD
mod0_dtrproc:
; DTR/CTS -> Busy
        bst     tmp2,BUSYpin            ;   Busy  T
        bld     poutB,CTSpin            ;   Busy  CTS
        eor     poutB,invCTS            ;  CTS;
        sbrs    tmp1,DTRpin             ;   DTR
        rjmp    mod0_dtrL               ; ,  DTR = 0
mod0_dtrH:
        cbi     CTAcfg,BUSYpin          ;  DTR=1, Busy   IN
        cbi     CTAout,BUSYpin          ;
        rjmp    mod0_portfin            ; 
mod0_dtrL:
        sbi     CTAout,BUSYpin          ;  DTR=0, Busy  PP=1
        sbi     CTAcfg,BUSYpin          ;
        cbr     poutB,(1<<CTSpin)       ; CTS = 0
mod0_portfin:
        out     CTBout,poutB            ;      B
;  
        sbic    CTBin,KEYpin            ;     
        rjmp    mod0_loop               ;  
        ret                             ;    

;______________________________________________________________
;  1: K-  , BUSY     +5
mode1:
        rcall   rst_iface               ;    ,  
;     
mod1_loop:
        wdr                             ;
        in      tmp1,CTBin              ;   B
        in      tmp2,CTAin              ;   A
; TxD/RxD -> Bus+
        bst     tmp2,BUSPpin            ;   Bus+  T
        bld     poutB,RXDpin            ;   Bus+  RxD
        bst     tmp1,TXDpin             ;   TxD  T
        brts    mod1_busH               ; ,    RxD  (TxD = 1)
        sbi     CTAcfg,BUSPpin          ; Bus+ = 0
        rjmp    mod1_dtrproc            ; 
mod1_busH:
        cbi     CTAcfg,BUSPpin          ; Bus+ = 1
mod1_dtrproc:
; DTR/CTS -> Busy
        bst     tmp2,BUSYpin            ;   Busy  T
        bld     poutB,CTSpin            ;   Busy  CTS
        eor     poutB,invCTS            ;  CTS

        bst     tmp1,DTRpin             ;   DTR  T
        brtc    mod1_dtrL               ; ,  DTR = 0
mod1_dtrH:
        cbi     CTAcfg,BUSYpin          ;  DTR=1, Busy   IN
        cbi     CTAout,BUSYpin          ;
        rjmp    mod1_portfin            ; 
mod1_dtrL:
        sbi     CTAout,BUSYpin          ;  DTR=0, Busy  PP=1
        sbi     CTAcfg,BUSYpin          ;
        cbr     poutB,(1<<CTSpin)       ; CTS = 0
mod1_portfin:
        out     CTBout,poutB            ;      B
;  
        sbic    CTBin,KEYpin            ;     
        rjmp    mod1_loop               ;  
        ret                             ;    

;______________________________________________________________
;  2:  UART, BUSY     +5
mode2:
        rcall   rst_iface               ;    ,  
;     
mod2_loop:
        wdr                             ;
        in      tmp1,CTBin              ;   B
        in      tmp2,CTAin              ;   A
; TxD/RxD -> Bus+
        bst     tmp2,BUSPpin            ;   Bus+  T
        bld     poutB,RXDpin            ;   Bus+  RxD

        sbrc    tmp1,TXDpin             ;   TxD
        rjmp    mod2_sciH               ; ,  TxD = 1
mod2_sciL:
        sbi     CTAcfg,SCIRpin          ; SCI RX+ = 0 (out)
        rjmp    mod2_dtrproc            ;    DTR
mod2_sciH:
        cbi     CTAcfg,SCIRpin          ; SCI RX+ = 1 (in)
mod2_dtrproc:
; DTR/CTS -> Busy
        bst     tmp2,BUSYpin            ;   Busy  T
        bld     poutB,CTSpin            ;   Busy  CTS
        eor     poutB,invCTS            ;  CTS

        bst     tmp1,DTRpin             ;   DTR  T
        brtc    mod2_dtrL               ; ,  DTR = 0
mod2_dtrH:
        cbi     CTAcfg,BUSYpin          ;  DTR=1, Busy   IN
        cbi     CTAout,BUSYpin          ;
        rjmp    mod2_portfin            ; 
mod2_dtrL:
        sbi     CTAout,BUSYpin          ;  DTR=0, Busy  PP=1
        sbi     CTAcfg,BUSYpin          ;
        cbr     poutB,(1<<CTSpin)       ; CTS = 0
mod2_portfin:
        out     CTBout,poutB            ;      B
;  
        sbic    CTBin,KEYpin            ;     
        rjmp    mod2_loop               ;  
        ret                             ;    

;______________________________________________________________
;  ,     
main_rstcold:
        cli                             ;   
;   
        wdr                             ;   
        in      tmp1,WDTCSR             ;   
        ori     tmp1,(1<<WDCE)|(1<<WDE) ;   WD
        out     WDTCSR,tmp1             ;    , 4   
        ldi     tmp1,(1<<WDE)|(0<<WDP2) ;  WD  0.25
        out     WDTCSR,tmp1             ;    
;  
        ldi     tmp1,low(RAMEND)        ;    L
        out     SPL,tmp1                ;  
        ldi     tmp1,high(RAMEND)       ;    H
        out     SPH,tmp1                ;  
;     A
        ldi     tmp1,CTA_OUT            ;   
        out     CTAout,tmp1             ;     
        ldi     tmp1,CTA_CFG            ;   
        out     CTAcfg,tmp1             ;  I/O 
;     B
        ldi     poutB,CTB_OUT           ;   
        out     CTBout,poutB            ;     

        ldi     tmp1,CTB_CFG            ;   
        out     CTBcfg,tmp1             ;  I/O 
        rcall   delay_long              ; 

        rcall   pwr_init                ;   +12

        ldi     tmp2,MA_PMOD            ;    
        rcall   eerd                    ;  EEPROM
        mov     pmod,tmp1               ;   
        rjmp    main_noinc              ;    
;  
main_loop:
        inc     pmod                    ;  
main_noinc:
        cpi     pmod,MAX_MOD+1          ;   
        brcs    main_pmodok             ; ,   
        clr     pmod                    ;     
main_pmodok:
        rcall   setled                  ;    
        mov     tmp1,pmod               ;  
        ldi     tmp2,MA_PMOD            ;    
        rcall   eewr                    ;  EEPROM
main_wtkey:
        wdr                             ;  WD
        sbis    CTBin,KEYpin            ;     
        rjmp    main_wtkey              ; ,    
        rcall   delay_long              ; 
;  : 2, 1, 0
        cpi     pmod,2                  ;    2
        breq    main_mode2              ; ,   2
        cpi     pmod,1                  ;    1
        breq    main_mode1              ; ,   1
;  0 - mbus (K-  )
main_mode0:
        rcall   mode0                   ;   0
        rjmp    main_loop               ;   
;  1 - K-
main_mode1:
        rcall   mode1                   ;   1
        rjmp    main_loop               ;   
;  2 - UART
main_mode2:
        rcall   mode2                   ;   2
        rjmp    main_loop               ;   
